DROP PROCEDURE WFDK_HISTHabitaciones_GetInfo
GO

CREATE PROCEDURE WFDK_HISTHabitaciones_GetInfo
    @Modo INT,
	@Fil_id_habi BIT,
	@vFil_id_habi INT,
	@vFil_id_habi2 INT,
	@Fil_fecha_ent BIT,
	@vFil_fecha_ent DATE,
	@vFil_fecha_ent2 DATE,
	@Fil_fecha_sal BIT,
	@vFil_fecha_sal DATE,
	@vFil_fecha_sal2 DATE,
	@Fil_fecha_estancia BIT,
	@vFil_fecha_estancia DATE,
	@vFil_fecha_estancia2 DATE,
	@Fil_id_agen BIT,
	@vFil_id_agen INT,
	@Fil_id_cont BIT,
	@vFil_id_cont INT,
	@Fil_id_merc BIT,
	@vFil_id_merc INT,
	@Fil_id_venta BIT,
	@vFil_id_venta INT,
	@Fil_nro_reserva BIT,
	@vFil_nro_reserva INT,
	@Fil_nro_rooming BIT,
	@vFil_nro_rooming INT,
	@Fil_id_ralo BIT,
	@vFil_id_ralo INT,
	@Fil_id_mone BIT,
	@vFil_id_mone INT,
	@Fil_id_thab BIT,
	@vFil_id_thab INT,
	@Fil_vip BIT,
	@vFil_vip BIT,
	@Fil_credito BIT,
	@vFil_credito BIT,
	@Fil_id_oper BIT,
	@vFil_id_oper INT,
	@Fil_referencia BIT,
	@vFil_referencia VARCHAR(255),
	@Fil_grupo BIT,
	@vFil_grupo VARCHAR(255),
	@Fil_nro_faca BIT,
	@vFil_nro_faca INT,
	@Fil_observaciones BIT,
	@vFil_observaciones VARCHAR(255),
	@Fil_id_care BIT,
	@vFil_id_care INT,
	@Fil_check_in_anul BIT,
	@Fil_salidas_hotelera BIT,
	@Fil_id_origen BIT,
	@vFil_id_origen INT,
	@Fil_nombre_reserv BIT,
	@vFil_nombre_reserv VARCHAR(255),
	@detallar_estancias BIT = 0
AS
BEGIN

	DECLARE @Fil VARCHAR(1000) = '' 

	DECLARE @fecha_hotelera DATE = (SELECT TOP 1 fecha_hotelera FROM HOTETABL)
	
	CREATE TABLE #HISTHabi
	(
		Habitacion VARCHAR(100),
		Nombre VARCHAR(1000), fecha_ent DATETIME,
		sp VARCHAR(500), fecha_sal DATETIME,
		sp1 VARCHAR(500), Contrato VARCHAR(500),
		sp2 VARCHAR(500),
		Precio NUMERIC(18, 2),
		Cod_mone VARCHAR(50), id_face INT, Cod_Ralo VARCHAR(50),
		referencia VARCHAR(500), tar_cred VARCHAR(100),
		fec_ent DATETIME,
		fec_sal DATETIME,
		id_cardex INT, adulto BIT, sexo BIT,
		dni_cif VARCHAR(100), nacionalidad VARCHAR(50), fecha_nac DATETIME,
		localidad VARCHAR(100), ciudad VARCHAR(100), direccion VARCHAR(500), zip_code VARCHAR(50),
		provincia VARCHAR(100), tipo_doc BIT, venc_pas DATETIME, desc_grupo VARCHAR(100),
		porc_dcto NUMERIC(6, 2), tipo_dcto INT, vip BIT,
		Observaciones VARCHAR(1000), 
		AgenteVtas VARCHAR(100),
		Nombre1 VARCHAR(100),
		nro_rooming INT,
		nro_reserva INT,
		proforma INT,
		hcli_cin_anulado BIT,
		hhab_cin_anulado BIT,
		id_agen INT, id_cont INT, id_merc INT,
	    id_ralo INT, id_mone INT, id_thab INT,
	    credito BIT, id_oper INT, id_origen INT,
	    Hospedaje NUMERIC(18, 2),
	    Regimen NUMERIC(18, 2),
	    Otros NUMERIC(18, 2),
	    id_rese INT
	)

	INSERT #HISTHabi
	Select Habitacion, 
	       hotehcli.Nombre, hotehhab.fecha_ent, 
	       sp = Space(3), hotehhab.fecha_sal, 
	       sp1 = Space(3), Contrato, 
	       sp2 = Space(3), 
	       Precio = Convert(Numeric(15,2),Case When hoteagen.directo = 1 
	                                           then dbo.Habitacion_tarifa(hotehhab.id_face) 
	                                           else Convert(numeric(15, 2), 0.00) 
	                                           end),
	       Cod_mone, hotehhab.id_face, Cod_Ralo, 
	       hotehhab.referencia, hotehhab.tar_cred, 
	       hotehcli.fecha_ent as fec_ent, 
	       hotehcli.fecha_sal as fec_sal,
	       hotehcli.id_cardex, adulto, sexo, 
	       dni_cif, nacionalidad, fecha_nac, 
	       localidad, ciudad, direccion, zip_code,
	       provincia, tipo_doc, venc_pas, desc_grupo,
	       hotehhab.porc_dcto, hotehhab.tipo_dcto, hotehhab.vip,
	       Observaciones = Convert(varchar(500), Hotehhab.Observaciones),
	       HOTEVENTA.Nombre AgenteVtas, 
	       Nombre1 = (Select hcli2.Nombre 
	                  From   Hotehcli hcli2  
	                  where  hcli2.id_facn = (Select Min(hcli3.id_facn)  
	                                          From   hotehcli hcli3   
	                                          Where  hcli3.id_face = hotehhab.id_face )), 
	       nro_rooming = Case When hotehhab.id_room is null Then hotehhab.id_room    
	                          When hotehrom.id_room is not null Then hotehrom.nro_rooming   
	                          When hoteroom.id_room is not null Then hoteroom.nro_rooming 
	                          End, 
	       nro_reserva = Case When hotehhab.id_rese is null Then hotehhab.id_rese    
	                          When hotehres.id_rese is not null Then hotehres.nro_reserva   
	                          When hoterese.id_rese is not null Then hoterese.nro_reserva 
	                          End,  
	       proforma = Case When hotehhab.id_faca is null Then hotehhab.id_faca    
	                       When hotehfag.id_faca is not null Then hotehfac.nro_cheque   
	                       When hotefaca.id_faca is not null Then hotefaca.nro_cheque 
	                       End,
	       HOTEHCLI.cin_anulado hcli_cin_anulado,  
	       HOTEHHAB.cin_anulado hhab_cin_anulado,
	       hotecont.id_agen, HOTEHHAB.id_cont, HOTECONT.id_merc,
	       HOTEHHAB.id_ralo, SICLAMON.id_mone, HOTETHAB.id_thab,
	       HOTEHHAB.credito, HOTEHHAB.id_oper, HOTEHHAB.id_origen,
	       CAST(0 AS NUMERIC(18, 2)) Hospedaje,
	       CAST(0 AS NUMERIC(18, 2)) Regimen,
	       CAST(0 AS NUMERIC(18, 2)) Otros,
	       HOTEHHAB.id_rese
	From       Hotehhab 
	inner join hotehcli  on hotehhab.id_face  = hotehcli.id_face               
	inner join hotehabi  on hotehhab.id_habi  = hotehabi.id_habi               
	inner join hotethab  on hotehabi.id_thab  = hotethab.id_thab               
	inner join hotecont  on hotehhab.id_cont  = hotecont.id_cont               
	inner join hoteagen  on hotecont.id_agen  = hoteagen.id_agen               
	inner join siclamon  on hotehhab.id_mone  = siclamon.id_mone               
	inner join hoteralo  on hotehhab.id_ralo  = hoteralo.id_ralo               
	inner join hotenaci  on hotehcli.id_naci  = hotenaci.id_naci               
	left  join hoteroom  on hotehhab.id_room  = hoteroom.id_room               
	left  join hotehrom  on hotehhab.id_room  = hotehrom.id_room               
	left  join hoterese  on hotehhab.id_rese  = hoterese.id_rese               
	left  join hotehres  on hotehhab.id_rese  = hotehres.id_rese               
	left  join hotefaca  on hotehhab.id_faca  = hotefaca.id_faca               
	left  join hotehfag  on hotehhab.id_faca  = hotehfag.id_faca               
	left  join hotehfac  on hotehfag.id_hfac  = hotehfac.id_hfac                
	left  join hoteventa on hotehhab.id_venta = hoteventa.id_venta 
	  
	IF @Fil_id_habi = 1 
	BEGIN 
	
		DECLARE @vHabIni VARCHAR(9) = (SELECT habitacion FROM HOTEHABI WHERE id_habi = @vFil_id_habi)
	    DECLARE @vHabFin VARCHAR(9) = (SELECT habitacion FROM HOTEHABI WHERE id_habi = @vFil_id_habi2)
	    
	    IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENRoom: ' + LTRIM(RTRIM(@vHabIni)) + ' -> ' + LTRIM(RTRIM(@vHabFin))
	    
	    DELETE #HISTHabi WHERE (CAST(Habitacion AS VARCHAR) < @vHabIni or CAST(Habitacion AS VARCHAR) > @vHabFin)
		
	END
	IF @Fil_fecha_ent = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKEntrada: ' + CAST(@vFil_fecha_ent AS VARCHAR) + ' -> ' + CAST(@vFil_fecha_ent2 AS VARCHAR)
	
	    DELETE #HISTHabi WHERE CAST(fecha_ent AS DATE) NOT BETWEEN @vFil_fecha_ent AND @vFil_fecha_ent2
	END
	IF @Fil_fecha_sal = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENSalida: ' + CAST(@vFil_fecha_sal AS VARCHAR) + ' -> ' + CAST(@vFil_fecha_sal2 AS VARCHAR)
	
	    DELETE #HISTHabi WHERE CAST(fecha_sal AS DATE) NOT BETWEEN @vFil_fecha_sal AND @vFil_fecha_sal2
	END
	IF @Fil_fecha_estancia = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKEstancia: ' + CAST(@vFil_fecha_estancia AS VARCHAR) + ' -> ' + CAST(@vFil_fecha_estancia2 AS VARCHAR)
	
	    DELETE #HISTHabi 
	    WHERE NOT (DateDiff(day, fecha_ent, @vFil_fecha_estancia) >= 0 and DateDiff(day, @vFil_fecha_estancia2, fecha_sal) > 0)
	END
	IF @Fil_id_agen = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENAgencia: ' + ISNULL((SELECT LTRIM(RTRIM(agencia)) FROM HOTEAGEN WHERE id_agen = @vFil_id_agen), '')
	
	    DELETE #HISTHabi WHERE ISNULL(id_agen, 0) <> @vFil_id_agen  
	END
	IF @Fil_id_cont = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENTarifa: ' + ISNULL((SELECT LTRIM(RTRIM(contrato)) FROM HOTECONT WHERE id_cont = @vFil_id_cont), '')
	
	    DELETE #HISTHabi WHERE ISNULL(id_cont, 0) <> @vFil_id_cont  
	END
	IF @Fil_id_merc = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKSMercado: ' + ISNULL((SELECT LTRIM(RTRIM(desc_merc)) FROM HOTEMERC WHERE id_merc = @vFil_id_merc), '')
	
	    DELETE #HISTHabi WHERE ISNULL(id_merc, 0) <> @vFil_id_merc  
	END
	IF @Fil_id_venta = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKSAgenteVentas: ' + ISNULL((SELECT LTRIM(RTRIM(Nombre)) FROM HOTEVENTA WHERE id_venta = @vFil_id_venta), '')
	
	    DELETE #HISTHabi WHERE ISNULL(id_venta, 0) <> @vFil_id_venta  
	END
	IF @Fil_nro_reserva = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKNroReserva: ' + CAST(@vFil_nro_reserva AS VARCHAR)
	
	    DELETE #HISTHabi WHERE ISNULL(nro_reserva, 0) <> @vFil_nro_reserva  
	END
	IF @Fil_nro_rooming = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKNroRooming: ' + CAST(@vFil_nro_rooming AS VARCHAR) 
	
	    DELETE #HISTHabi WHERE ISNULL(nro_rooming, 0) <> @vFil_nro_rooming  
	END
	IF @Fil_id_ralo = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKSEXRegimen: ' + ISNULL((SELECT LTRIM(RTRIM(cod_ralo)) FROM HOTERALO WHERE id_ralo = @vFil_id_ralo), '')
	
	    DELETE #HISTHabi WHERE ISNULL(id_ralo, 0) <> @vFil_id_ralo  
	END
	IF @Fil_id_mone = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENMoney: ' + ISNULL((SELECT LTRIM(RTRIM(cod_mone)) FROM SICLAMON WHERE id_mone = @vFil_id_mone), '')
	
	    DELETE #HISTHabi WHERE ISNULL(id_mone, 0) <> @vFil_id_mone  
	END
	IF @Fil_id_thab = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENRoomType: ' + ISNULL((SELECT LTRIM(RTRIM(tipo_hab)) FROM HOTETHAB WHERE id_thab = @vFil_id_thab), '')
	
	    DELETE #HISTHabi WHERE ISNULL(id_thab, 0) <> @vFil_id_thab  
	END
	IF @Fil_vip = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'VIP: ' + CASE @vFil_vip WHEN 1 THEN 'LblGENYes' ELSE 'LblGENNo' END
	
	    DELETE #HISTHabi WHERE ISNULL(vip, 0) <> @vFil_vip  
	END
	IF @Fil_credito = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKCredito: ' + CASE @vFil_credito WHEN 1 THEN 'LblGENYes' ELSE 'LblGENNo' END
	
	    DELETE #HISTHabi WHERE ISNULL(credito, 0) <> @vFil_credito  
	END
	IF @Fil_id_oper = 1 
	BEGIN 
		
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENUser: ' + ISNULL((SELECT nombre FROM IHSecurity..Operador WHERE id_oper = @vFil_id_oper), '')
	
	    DELETE #HISTHabi WHERE ISNULL(id_oper, 0) <> @vFil_id_oper  
	END
	IF @Fil_referencia = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENReference: ' + LTRIM(RTRIM(@vFil_referencia))
	
	    DELETE #HISTHabi WHERE referencia IS NULL OR LEN(LTRIM(RTRIM(referencia))) = 0 OR 
			LTRIM(RTRIM(LOWER(referencia))) NOT LIKE '%' + LTRIM(RTRIM(LOWER(@vFil_referencia))) + '%' 
	END
	IF @Fil_grupo = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENGroup: ' + @vFil_grupo
	
	    DELETE #HISTHabi WHERE desc_grupo IS NULL OR LEN(LTRIM(RTRIM(desc_grupo))) = 0 OR
			LTRIM(RTRIM(LOWER(desc_grupo))) NOT LIKE '%' + LTRIM(RTRIM(LOWER(@vFil_grupo))) + '%' 
	END
	IF @Fil_nro_faca = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKProforma: ' + CAST(@Fil_nro_faca AS VARCHAR)
	
	    DELETE #HISTHabi WHERE ISNULL(proforma, 0) <> @vFil_nro_faca  
	END
	IF @Fil_observaciones = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENObservations: ' + LTRIM(RTRIM(@vFil_observaciones))
	
	    DELETE #HISTHabi WHERE observaciones IS NULL OR LEN(LTRIM(RTRIM(observaciones))) = 0 OR 
			LTRIM(RTRIM(LOWER(observaciones))) NOT LIKE '%' + LTRIM(RTRIM(LOWER(@vFil_observaciones))) + '%' 
	END
	IF @Fil_id_care = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKPerfilEmpresa: ' + ISNULL((SELECT LTRIM(RTRIM(clave_cardex)) FROM HOTECARD WHERE id_cardex = @vFil_id_care), '')
	
	    DELETE #HISTHabi WHERE NOT dbo.Is_Habit_Cardex_Empresa(id_face, @vFil_id_care) = 1
	END
	IF @Fil_check_in_anul = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKHHHabCKINAnul' 
	
	    DELETE #HISTHabi 
	    Where hcli_cin_anulado = 0 
	      and hhab_cin_anulado = 0 
	END
	ELSE
	BEGIN
		DELETE #HISTHabi 
	    Where hcli_cin_anulado = 1 
	      and hhab_cin_anulado = 1 
	END
	IF @Fil_salidas_hotelera = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKHHSalidasDiaActual' 
	
	    DELETE #HISTHabi WHERE NOT (DateDiff(day, @fecha_hotelera, fecha_sal) = 0 and id_face not in (Select id_face from hoteface)) 
	END
	IF @Fil_id_origen = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENOrigen: ' + ISNULL((SELECT LTRIM(RTRIM(Desc_Origen)) FROM HOTERLOR WHERE id_origen = @vFil_id_origen), '')
	
	    DELETE #HISTHabi WHERE id_origen <> @vFil_id_origen  
	END
	
	IF @Fil_nombre_reserv = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKNombreReservante: ' + LTRIM(RTRIM(@vFil_nombre_reserv))
	
	    DELETE #HISTHabi WHERE ISNULL(id_rese, 0) NOT IN  (SELECT id_rese 
														   FROM   HOTERESE 
														   WHERE  nomb_reserv IS NOT NULL 
															 AND  LEN(LTRIM(RTRIM(nomb_reserv))) > 0 
															 AND  LTRIM(RTRIM(LOWER(nomb_reserv))) LIKE '%' + LTRIM(RTRIM(LOWER(@vFil_nombre_reserv))) + '%'
														   UNION
														   SELECT id_rese 
														   FROM   HOTEHRES 
														   WHERE  nomb_reserv IS NOT NULL 
															 AND  LEN(LTRIM(RTRIM(nomb_reserv))) > 0 
															 AND  LTRIM(RTRIM(LOWER(nomb_reserv))) LIKE '%' + LTRIM(RTRIM(LOWER(@vFil_nombre_reserv))) + '%') 
	END
	
	IF @Modo = 1
	BEGIN
		SELECT TOP 300 ROW_NUMBER() OVER(ORDER BY id_face DESC) Id, 
		       id_face, Habitacion, MAX(Nombre1) Nombre, fecha_ent, fecha_sal,
		       Contrato, Precio, Cod_Mone, SUM(1) Pax, id_face Boton,
		       0 eliminado
		FROM #HISTHabi
		GROUP BY id_face, Habitacion, fecha_ent, fecha_sal,
		         Contrato, Precio, Cod_Mone
		ORDER BY fecha_ent ASC
	END
	ELSE
	BEGIN
	
		CREATE TABLE #TempImpoFras
		(
			id_origen INT,
			Hospedaje NUMERIC(18, 2),
			Regimen NUMERIC(18, 2),
			Otros NUMERIC(18, 2)
		)
		
		DECLARE @Aux VARCHAR(50)
		
		DECLARE @Hospedaje NUMERIC(18, 2) = 0
		DECLARE @Regimen NUMERIC(18, 2) = 0
		DECLARE @Otros NUMERIC(18, 2) = 0
		
		DECLARE @Ini INT = (SELECT MIN(id_face) FROM #HISTHabi)
		DECLARE @Fin INT = (SELECT MAX(id_face) FROM #HISTHabi)
		DECLARE @Act INT = @Ini
		
		WHILE @Act <= @Fin
		BEGIN
		
			IF EXISTS (SELECT id_face FROM #HISTHabi WHERE id_face = @Act)
			BEGIN
			
				SET @Aux = CAST(@Act AS VARCHAR)
				
				SET @Hospedaje = 0
				SET @Regimen = 0
				SET @Otros = 0
				
				INSERT #TempImpoFras
				EXEC Calc_Facturas_importes @Aux, NULL
				
				SELECT @Hospedaje = Hospedaje,
				       @Regimen = Regimen,
				       @Otros = Otros
				FROM   #TempImpoFras
				WHERE  id_origen = @Act
				
				UPDATE #HISTHabi
				SET    Hospedaje = ISNULL(@Hospedaje, 0),
				       Regimen = ISNULL(@Regimen, 0),
				       Otros = ISNULL(@Otros, 0)
				WHERE  id_face = @Act
				
				DELETE #TempImpoFras
				
			END
			
			SET @Act = @Act + 1
			
		END
		
		-- Tal cual en rep_hishab.frx
		UPDATE #HISTHabi
		SET    Precio = CAST(ISNULL(Hospedaje / DATEDIFF(DAY, fecha_ent, fecha_sal), 0) AS NUMERIC(18, 2))
		WHERE  Precio <= 10
		
		IF @detallar_estancias = 0
		BEGIN
	
			SELECT id_face, Habitacion, MAX(Nombre1) Nombre, fecha_ent, fecha_sal,
				   Contrato, DATEDIFF(DAY, fecha_ent, fecha_sal) Noches, 
				   SUM(1) Pax, Precio, Hospedaje, Regimen, Otros, Cod_Mone
			FROM #HISTHabi
			GROUP BY id_face, Habitacion, fecha_ent, fecha_sal,
					 Contrato, Precio, Hospedaje, Regimen, Otros, Cod_Mone
			ORDER BY fecha_ent ASC
		
		END
		ELSE
		BEGIN
			
			CREATE TABLE #HISTHabiDetEst
			(
				Habitacion VARCHAR(100),
				Nombre VARCHAR(1000), fecha_ent DATETIME,
				sp VARCHAR(500), fecha_sal DATETIME,
				sp1 VARCHAR(500), Contrato VARCHAR(500),
				sp2 VARCHAR(500),
				Precio NUMERIC(18, 2),
				Cod_mone VARCHAR(50), id_face INT, Cod_Ralo VARCHAR(50),
				referencia VARCHAR(500), tar_cred VARCHAR(100),
				fec_ent DATETIME,
				fec_sal DATETIME,
				id_cardex INT, adulto BIT, sexo BIT,
				dni_cif VARCHAR(100), nacionalidad VARCHAR(50), fecha_nac DATETIME,
				localidad VARCHAR(100), ciudad VARCHAR(100), direccion VARCHAR(500), zip_code VARCHAR(50),
				provincia VARCHAR(100), tipo_doc BIT, venc_pas DATETIME, desc_grupo VARCHAR(100),
				porc_dcto NUMERIC(6, 2), tipo_dcto INT, vip BIT,
				Observaciones VARCHAR(1000), 
				AgenteVtas VARCHAR(100),
				Nombre1 VARCHAR(100),
				nro_rooming INT,
				nro_reserva INT,
				proforma INT,
				hcli_cin_anulado BIT,
				hhab_cin_anulado BIT,
				id_agen INT, id_cont INT, id_merc INT,
				id_ralo INT, id_mone INT, id_thab INT,
				credito BIT, id_oper INT, id_origen INT,
				Hospedaje NUMERIC(18, 2),
				Regimen NUMERIC(18, 2),
				Otros NUMERIC(18, 2),
				id_rese INT,
				fecha_estancia DATETIME
			)
			
			DECLARE @HHIni INT = (SELECT MIN(id_face) FROM #HISTHabi)
			DECLARE @HHFin INT = (SELECT MAX(id_face) FROM #HISTHabi)
			DECLARE @HHAct INT = @HHIni
			
			DECLARE @HHFecIni DATE, @HHFecFin DATE, @HHFecAct DATE 
			
			--DECLARE @Primero BIT = 1
			
			WHILE @HHAct <= @HHFin
			BEGIN
				IF EXISTS (SELECT id_face FROM #HISTHabi WHERE id_face = @HHAct)
				BEGIN
					SELECT @HHFecIni = fecha_ent,
					       @HHFecFin = fecha_sal,
					       @HHFecAct = fecha_ent
					FROM   #HISTHabi 
					WHERE  id_face = @HHAct
					
					--SET @Primero = 1
					
					WHILE DATEDIFF(DAY, @HHFecAct, @HHFecFin) <> 0 
					BEGIN
						INSERT #HISTHabiDetEst
						SELECT Habitacion,
							   Nombre, fecha_ent,
							   sp, fecha_sal,
							   sp1, Contrato,
							   sp2,
							   Precio,
							   Cod_mone, id_face, Cod_Ralo,
							   referencia, tar_cred,
							   fec_ent,
							   fec_sal,
							   id_cardex, adulto, sexo,
							   dni_cif, nacionalidad, fecha_nac,
							   localidad, ciudad, direccion, zip_code,
							   provincia, tipo_doc, venc_pas, desc_grupo,
							   porc_dcto, tipo_dcto, vip,
							   Observaciones, 
							   AgenteVtas,
							   Nombre1,
							   nro_rooming,
							   nro_reserva,
							   proforma,
							   hcli_cin_anulado,
							   hhab_cin_anulado,
							   id_agen, id_cont, id_merc,
							   id_ralo, id_mone, id_thab,
							   credito, id_oper, id_origen,
							   CASE DATEDIFF(DAY, @HHFecAct, @HHFecFin) WHEN 1 THEN Hospedaje ELSE 0 END Hospedaje,
							   CASE DATEDIFF(DAY, @HHFecAct, @HHFecFin) WHEN 1 THEN Regimen ELSE 0 END Regimen,
							   CASE DATEDIFF(DAY, @HHFecAct, @HHFecFin) WHEN 1 THEN Otros ELSE 0 END Otros,
							   id_rese,
							   @HHFecAct
						FROM   #HISTHabi WHERE id_face = @HHAct
						
						--SET @Primero = 0
					
						SET @HHFecAct = DATEADD(DAY, 1, @HHFecAct)
					END
				END
			
				SET @HHAct = @HHAct + 1
			END
			
			IF LEN(LTRIM(RTRIM(@Fil))) > 0
			BEGIN
				SET @Fil = @Fil + ', '
			END
			
			SET @Fil = @Fil + 'LblFDKDetallarEstancias'
			
			SELECT id_face, Habitacion, MAX(Nombre1) Nombre, fecha_ent, fecha_sal,
				   Contrato, DATEDIFF(DAY, fecha_ent, fecha_sal) Noches, 
				   SUM(1) Pax, Precio, Hospedaje, Regimen, Otros, Cod_Mone, fecha_estancia
			FROM #HISTHabiDetEst
			GROUP BY id_face, Habitacion, fecha_ent, fecha_sal,
					 Contrato, Precio, Hospedaje, Regimen, Otros, Cod_Mone, fecha_estancia
			ORDER BY fecha_ent ASC
			
		END
		
		SELECT @Fil Filtro
		
	END

	RETURN
	
END