DROP PROCEDURE WFDK_HISTRepitentes_GetInfo
GO

CREATE PROCEDURE WFDK_HISTRepitentes_GetInfo
	@Modo INT,
	@Fil_nombre BIT,
	@Fil_perfil BIT,
	@Fil_pasaporte BIT,
	@Fil_fecha_ent BIT,
	@vFil_fecha_ent DATE,
	@vFil_fecha_ent2 DATE,
	@Fil_fecha_sal BIT,
	@vFil_fecha_sal DATE,
	@vFil_fecha_sal2 DATE,
	@Fil_estancias BIT,
	@vFil_estancias INT
AS
BEGIN

	DECLARE @Fil VARCHAR(500) = '' 
	DECLARE @Fil2 VARCHAR(500) = '' 

	Select hotehhab.id_face,
	       Nombre = Max(Upper(Nombre)),
	       dni_cif = Max(hotehcli.dni_cif), 
	       Desc_nac = Max(nacionalidad),
	       Clave_Cardex = Max(clave_cardex), 
	       Fecha_ent = Min(hotehcli.fecha_ent),
	       Fecha_Sal = Max(hotehcli.fecha_sal), 
	       habitacion,
	       Precio = Convert(Numeric(15,2), Case When hoteagen.directo = 1 then dbo.Habitacion_tarifa(hotehhab.id_face) 
	                                       else Convert(numeric(15,2), 0.00) 
	                                       end), 
	       Contrato,cod_mone,
	       0 estancias,
	       CAST('' AS VARCHAR(1000)) Agrupador1,
	       CAST('' AS VARCHAR(1000)) Agrupador2,
	       CAST('' AS VARCHAR(1000)) Agrupador3,
	       0 Total
	INTO #HISTRepitentes 
	From       Hotehhab 
	inner join hotehcli on hotehhab.id_face = hotehcli.id_face
	inner join hotehabi on hotehhab.id_habi = hotehabi.id_habi
	inner join hotenaci on hotehcli.id_naci = hotenaci.id_naci
	inner join hotecont on hotehhab.id_cont = hotecont.id_cont
	inner join hoteagen on hotecont.id_agen = hoteagen.id_agen
	inner join siclamon on hotehhab.id_mone = siclamon.id_mone
	left  join hotecard on hotehcli.id_cardex = hotecard.id_cardex 
	Where hotehcli.cin_anulado = 0 
	  and hotehhab.cin_anulado = 0  
	Group by hotehhab.id_face, habitacion, precio, Contrato, cod_mone, directo  
	Order by Nombre
	
	IF @Fil_nombre = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblGENName' 
	
	    DELETE #HISTRepitentes WHERE LEN(LTRIM(RTRIM(ISNULL(nombre, '')))) = 0  
	END
	IF @Fil_perfil = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKPerfil' 
	
	    DELETE #HISTRepitentes WHERE LEN(LTRIM(RTRIM(ISNULL(clave_cardex, '')))) = 0   
	END
	IF @Fil_pasaporte = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil))) > 0
		BEGIN
			SET @Fil = @Fil + ', '
		END
		
		SET @Fil = @Fil + 'LblFDKPasaporte' 
	
	    DELETE #HISTRepitentes WHERE LEN(LTRIM(RTRIM(ISNULL(dni_cif, '')))) = 0  
	END
	IF @Fil_fecha_ent = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil2))) > 0
		BEGIN
			SET @Fil2 = @Fil2 + ', '
		END
		
		SET @Fil2 = @Fil2 + 'LblFDKEntrada: ' + CAST(@vFil_fecha_ent AS VARCHAR) + ' -> ' + CAST(@vFil_fecha_ent2 AS VARCHAR)
	
	    DELETE #HISTRepitentes WHERE CAST(fecha_ent AS DATE) NOT BETWEEN @vFil_fecha_ent AND @vFil_fecha_ent2
	END
	IF @Fil_fecha_sal = 1 
	BEGIN 
	
		IF LEN(LTRIM(RTRIM(@Fil2))) > 0
		BEGIN
			SET @Fil2 = @Fil2 + ', '
		END
		
		SET @Fil2 = @Fil2 + 'LblGENSalida: ' + CAST(@vFil_fecha_sal AS VARCHAR) + ' -> ' + CAST(@vFil_fecha_sal2 AS VARCHAR)
	
	    DELETE #HISTRepitentes WHERE CAST(fecha_sal AS DATE) NOT BETWEEN @vFil_fecha_sal AND @vFil_fecha_sal2
	END
	
	IF @Fil_estancias = 0 SET @Fil_estancias = 1
	IF @vFil_estancias < 1 SET @vFil_estancias = 1
	
	IF LEN(LTRIM(RTRIM(@Fil2))) > 0
	BEGIN
		SET @Fil2 = @Fil2 + ', '
	END
	
	SET @Fil2 = @Fil2 + 'LblFDKEstancias: ' + CAST(@vFil_estancias AS VARCHAR) + '+' 
	
	-- Parte compleja
	
	IF @Fil_nombre = 1 AND @Fil_perfil = 1 AND @Fil_pasaporte = 1 
	BEGIN
		UPDATE #HISTRepitentes 
		SET estancias = ISNULL((SELECT SUM(1)
		                 FROM   #HISTRepitentes Repi
		                 WHERE  LTRIM(RTRIM(LOWER(#HISTRepitentes.nombre))) = LTRIM(RTRIM(LOWER(Repi.nombre)))
		                   AND  LTRIM(RTRIM(LOWER(#HISTRepitentes.clave_cardex))) = LTRIM(RTRIM(LOWER(Repi.clave_cardex)))
		                   AND  LTRIM(RTRIM(LOWER(#HISTRepitentes.dni_cif))) = LTRIM(RTRIM(LOWER(Repi.dni_cif)))
		                 GROUP BY LTRIM(RTRIM(LOWER(Repi.nombre))), LTRIM(RTRIM(LOWER(Repi.clave_cardex))), LTRIM(RTRIM(LOWER(Repi.dni_cif)))), 0)
		                 
		UPDATE #HISTRepitentes
		SET Agrupador1 = LTRIM(RTRIM(LOWER(nombre))),
		    Agrupador2 = LTRIM(RTRIM(LOWER(clave_cardex))),
		    Agrupador3 = LTRIM(RTRIM(LOWER(dni_cif)))
		FROM  #HISTRepitentes
		                 
		IF @Fil_estancias = 1 
		BEGIN 
		   DELETE #HISTRepitentes WHERE estancias <= @vFil_estancias  
		END 
		
	END 
	
	IF @Fil_nombre = 1 AND @Fil_perfil = 0 AND @Fil_pasaporte = 1
	BEGIN
	
		UPDATE #HISTRepitentes 
		SET estancias = ISNULL((SELECT SUM(1)
		                 FROM   #HISTRepitentes Repi
		                 WHERE  LTRIM(RTRIM(LOWER(#HISTRepitentes.nombre))) = LTRIM(RTRIM(LOWER(Repi.nombre)))
		                   AND  LTRIM(RTRIM(LOWER(#HISTRepitentes.dni_cif))) = LTRIM(RTRIM(LOWER(Repi.dni_cif)))
		                 GROUP BY LTRIM(RTRIM(LOWER(Repi.nombre))), LTRIM(RTRIM(LOWER(Repi.dni_cif)))), 0)
		                 
		UPDATE #HISTRepitentes
		SET Agrupador1 = LTRIM(RTRIM(LOWER(nombre))),
		    Agrupador2 = LTRIM(RTRIM(LOWER(dni_cif))),
		    Agrupador3 = LTRIM(RTRIM(LOWER(dni_cif)))
		FROM  #HISTRepitentes
		                 
		IF @Fil_estancias = 1 
		BEGIN 
		   DELETE #HISTRepitentes WHERE estancias <= @vFil_estancias  
		END 
		
	END 
	
	IF @Fil_nombre = 0 AND @Fil_perfil = 0 AND @Fil_pasaporte = 0 
	BEGIN
		UPDATE #HISTRepitentes 
		SET estancias = ISNULL((SELECT SUM(1)
		                 FROM   #HISTRepitentes Repi
		                 WHERE  LTRIM(RTRIM(LOWER(#HISTRepitentes.nombre))) = LTRIM(RTRIM(LOWER(Repi.nombre)))
		                   AND  LTRIM(RTRIM(LOWER(#HISTRepitentes.clave_cardex))) = LTRIM(RTRIM(LOWER(Repi.clave_cardex)))
		                   AND  LTRIM(RTRIM(LOWER(#HISTRepitentes.dni_cif))) = LTRIM(RTRIM(LOWER(Repi.dni_cif)))
		                 GROUP BY LTRIM(RTRIM(LOWER(Repi.nombre))), LTRIM(RTRIM(LOWER(Repi.clave_cardex))), LTRIM(RTRIM(LOWER(Repi.dni_cif)))), 0)
		
		UPDATE #HISTRepitentes
		SET Agrupador1 = LTRIM(RTRIM(LOWER(nombre))),
		    Agrupador2 = LTRIM(RTRIM(LOWER(clave_cardex))),
		    Agrupador3 = LTRIM(RTRIM(LOWER(dni_cif)))
		FROM  #HISTRepitentes
		                 
		IF @Fil_estancias = 1 
		BEGIN 
		   DELETE #HISTRepitentes WHERE estancias <= @vFil_estancias  
		END 
		
	END 
	
	IF @Fil_nombre = 1 AND @Fil_perfil = 0 AND @Fil_pasaporte = 0
	BEGIN
		UPDATE #HISTRepitentes 
		SET estancias = ISNULL((SELECT SUM(1)
		                 FROM   #HISTRepitentes Repi
		                 WHERE  LTRIM(RTRIM(LOWER(#HISTRepitentes.nombre))) = LTRIM(RTRIM(LOWER(Repi.nombre)))
		                 GROUP BY LTRIM(RTRIM(LOWER(Repi.nombre)))), 0)
		
		UPDATE #HISTRepitentes
		SET Agrupador1 = LTRIM(RTRIM(LOWER(nombre))),
		    Agrupador2 = LTRIM(RTRIM(LOWER(nombre))),
		    Agrupador3 = LTRIM(RTRIM(LOWER(nombre)))
		FROM  #HISTRepitentes
		                 
		IF @Fil_estancias = 1 
		BEGIN 
		   DELETE #HISTRepitentes WHERE estancias <= @vFil_estancias  
		END 
		
	END 
	
	IF @Fil_nombre = 1 AND @Fil_perfil = 1 AND @Fil_pasaporte = 0
	BEGIN
		UPDATE #HISTRepitentes 
		SET estancias = ISNULL((SELECT SUM(1)
		                 FROM   #HISTRepitentes Repi
		                 WHERE  LTRIM(RTRIM(LOWER(#HISTRepitentes.nombre))) = LTRIM(RTRIM(LOWER(Repi.nombre)))
		                   AND  LTRIM(RTRIM(LOWER(#HISTRepitentes.clave_cardex))) = LTRIM(RTRIM(LOWER(Repi.clave_cardex)))
		                 GROUP BY LTRIM(RTRIM(LOWER(Repi.nombre))), LTRIM(RTRIM(LOWER(Repi.clave_cardex)))), 0)
		
		UPDATE #HISTRepitentes
		SET Agrupador1 = LTRIM(RTRIM(LOWER(nombre))),
		    Agrupador2 = LTRIM(RTRIM(LOWER(clave_cardex))),
		    Agrupador3 = LTRIM(RTRIM(LOWER(clave_cardex)))
		FROM  #HISTRepitentes
		                 
		IF @Fil_estancias = 1 
		BEGIN 
		   DELETE #HISTRepitentes WHERE estancias <= @vFil_estancias  
		END 
		
	END 
	
	IF @Fil_nombre = 0 AND @Fil_perfil = 1 AND @Fil_pasaporte = 1 
	BEGIN
		UPDATE #HISTRepitentes 
		SET estancias = ISNULL((SELECT SUM(1)
		                 FROM   #HISTRepitentes Repi
		                 WHERE  LTRIM(RTRIM(LOWER(#HISTRepitentes.clave_cardex))) = LTRIM(RTRIM(LOWER(Repi.clave_cardex)))
		                   AND  LTRIM(RTRIM(LOWER(#HISTRepitentes.dni_cif))) = LTRIM(RTRIM(LOWER(Repi.dni_cif)))
		                 GROUP BY LTRIM(RTRIM(LOWER(Repi.clave_cardex))), LTRIM(RTRIM(LOWER(Repi.dni_cif)))), 0)
		
		UPDATE #HISTRepitentes
		SET Agrupador1 = LTRIM(RTRIM(LOWER(clave_cardex))),
		    Agrupador2 = LTRIM(RTRIM(LOWER(dni_cif))),
		    Agrupador3 = LTRIM(RTRIM(LOWER(dni_cif)))
		FROM  #HISTRepitentes
		                 
		IF @Fil_estancias = 1 
		BEGIN 
		   DELETE #HISTRepitentes WHERE estancias <= @vFil_estancias  
		END 
		
	END 
	
	IF @Fil_nombre = 0 AND @Fil_perfil = 1 AND @Fil_pasaporte = 0
	BEGIN
		UPDATE #HISTRepitentes 
		SET estancias = ISNULL((SELECT SUM(1)
		                 FROM   #HISTRepitentes Repi
		                 WHERE  LTRIM(RTRIM(LOWER(#HISTRepitentes.clave_cardex))) = LTRIM(RTRIM(LOWER(Repi.clave_cardex)))
		                 GROUP BY LTRIM(RTRIM(LOWER(Repi.clave_cardex)))), 0)
		
		UPDATE #HISTRepitentes
		SET Agrupador1 = LTRIM(RTRIM(LOWER(clave_cardex))),
		    Agrupador2 = LTRIM(RTRIM(LOWER(clave_cardex))),
		    Agrupador3 = LTRIM(RTRIM(LOWER(clave_cardex)))
		FROM  #HISTRepitentes
		                 
		IF @Fil_estancias = 1 
		BEGIN 
		   DELETE #HISTRepitentes WHERE estancias <= @vFil_estancias  
		END 
		
	END 
	
	IF @Fil_nombre = 0 AND @Fil_perfil = 0 AND @Fil_pasaporte = 1
	BEGIN
		UPDATE #HISTRepitentes 
		SET estancias = ISNULL((SELECT SUM(1)
		                 FROM   #HISTRepitentes Repi
		                 WHERE  LTRIM(RTRIM(LOWER(#HISTRepitentes.dni_cif))) = LTRIM(RTRIM(LOWER(Repi.dni_cif)))
		                 GROUP BY LTRIM(RTRIM(LOWER(Repi.dni_cif)))), 0)
		
		UPDATE #HISTRepitentes
		SET Agrupador1 = LTRIM(RTRIM(LOWER(dni_cif))),
		    Agrupador2 = LTRIM(RTRIM(LOWER(dni_cif))),
		    Agrupador3 = LTRIM(RTRIM(LOWER(dni_cif)))
		FROM  #HISTRepitentes
		                 
		IF @Fil_estancias = 1 
		BEGIN 
		   DELETE #HISTRepitentes WHERE estancias <= @vFil_estancias  
		END 
	
	END 
	
	UPDATE #HISTRepitentes
	SET Total = ISNULL((SELECT SUM(a.Elem) 
	                    FROM (SELECT 1 Elem FROM #HISTRepitentes GROUP BY Agrupador1, Agrupador2, Agrupador3) a)
	            , 0)
	
	SELECT * FROM #HISTRepitentes
	
	SELECT @Fil Filtro, @Fil2 Filtro2
	
	RETURN
	
END